{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module OGDF.FMMMLayout.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import OGDF.FMMMLayout.RawType
import OGDF.FMMMLayout.FFI
import OGDF.FMMMLayout.Interface
import OGDF.FMMMLayout.Cast
import OGDF.FMMMLayout.RawType
import OGDF.FMMMLayout.Cast
import OGDF.FMMMLayout.Interface
import OGDF.GraphAttributes.RawType
import OGDF.GraphAttributes.Cast
import OGDF.GraphAttributes.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface
import OGDF.LayoutModule.RawType
import OGDF.LayoutModule.Cast
import OGDF.LayoutModule.Interface

instance () => IFMMMLayout (FMMMLayout) where

instance () => IDeletable (FMMMLayout) where
        delete = xform0 c_fmmmlayout_delete

instance () => ILayoutModule (FMMMLayout) where
        call = xform1 c_fmmmlayout_call

newFMMMLayout :: () => IO FMMMLayout
newFMMMLayout = xformnull c_fmmmlayout_newfmmmlayout

fMMMLayout_useHighLevelOptions ::
                                 () => FMMMLayout -> CBool -> IO ()
fMMMLayout_useHighLevelOptions
  = xform1 c_fmmmlayout_fmmmlayout_usehighleveloptions

fMMMLayout_unitEdgeLength :: () => FMMMLayout -> CDouble -> IO ()
fMMMLayout_unitEdgeLength
  = xform1 c_fmmmlayout_fmmmlayout_unitedgelength

fMMMLayout_newInitialPlacement ::
                                 () => FMMMLayout -> CBool -> IO ()
fMMMLayout_newInitialPlacement
  = xform1 c_fmmmlayout_fmmmlayout_newinitialplacement
