{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module OGDF.GraphAttributes.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import OGDF.GraphAttributes.RawType
import OGDF.GraphAttributes.RawType
import OGDF.Color.RawType
import OGDF.List.Template
import OGDF.DPoint.RawType
import STD.CppString.RawType
import OGDF.DRect.RawType
import OGDF.Graph.RawType
import OGDF.NodeElement.RawType
import OGDF.EdgeElement.RawType

foreign import ccall interruptible
               "OGDFGraphAttributes.h GraphAttributes_delete"
               c_graphattributes_delete :: Ptr RawGraphAttributes -> IO ()

foreign import ccall interruptible
               "OGDFGraphAttributes.h GraphAttributes_newGraphAttributes"
               c_graphattributes_newgraphattributes ::
               Ptr RawGraph -> CLong -> IO (Ptr RawGraphAttributes)

foreign import ccall interruptible
               "OGDFGraphAttributes.h GraphAttributes_graphAttributes_fillColor"
               c_graphattributes_graphattributes_fillcolor ::
               Ptr RawGraphAttributes -> Ptr RawNodeElement -> IO (Ptr RawColor)

foreign import ccall interruptible
               "OGDFGraphAttributes.h GraphAttributes_graphAttributes_fillBgColor"
               c_graphattributes_graphattributes_fillbgcolor ::
               Ptr RawGraphAttributes -> Ptr RawNodeElement -> IO (Ptr RawColor)

foreign import ccall interruptible
               "OGDFGraphAttributes.h GraphAttributes_graphAttributes_x"
               c_graphattributes_graphattributes_x ::
               Ptr RawGraphAttributes -> Ptr RawNodeElement -> IO (Ptr CDouble)

foreign import ccall interruptible
               "OGDFGraphAttributes.h GraphAttributes_graphAttributes_y"
               c_graphattributes_graphattributes_y ::
               Ptr RawGraphAttributes -> Ptr RawNodeElement -> IO (Ptr CDouble)

foreign import ccall interruptible
               "OGDFGraphAttributes.h GraphAttributes_graphAttributes_width"
               c_graphattributes_graphattributes_width ::
               Ptr RawGraphAttributes -> Ptr RawNodeElement -> IO (Ptr CDouble)

foreign import ccall interruptible
               "OGDFGraphAttributes.h GraphAttributes_graphAttributes_height"
               c_graphattributes_graphattributes_height ::
               Ptr RawGraphAttributes -> Ptr RawNodeElement -> IO (Ptr CDouble)

foreign import ccall interruptible
               "OGDFGraphAttributes.h GraphAttributes_graphAttributes_bends"
               c_graphattributes_graphattributes_bends ::
               Ptr RawGraphAttributes ->
                 Ptr RawEdgeElement -> IO (Ptr (RawList DPoint))

foreign import ccall interruptible
               "OGDFGraphAttributes.h GraphAttributes_graphAttributes_label"
               c_graphattributes_graphattributes_label ::
               Ptr RawGraphAttributes ->
                 Ptr RawNodeElement -> IO (Ptr RawCppString)

foreign import ccall interruptible
               "OGDFGraphAttributes.h GraphAttributes_graphAttributeslabelE"
               c_graphattributes_graphattributeslabele ::
               Ptr RawGraphAttributes ->
                 Ptr RawEdgeElement -> IO (Ptr RawCppString)

foreign import ccall interruptible
               "OGDFGraphAttributes.h GraphAttributes_graphAttributes_xLabel"
               c_graphattributes_graphattributes_xlabel ::
               Ptr RawGraphAttributes -> Ptr RawNodeElement -> IO (Ptr CDouble)

foreign import ccall interruptible
               "OGDFGraphAttributes.h GraphAttributes_graphAttributes_yLabel"
               c_graphattributes_graphattributes_ylabel ::
               Ptr RawGraphAttributes -> Ptr RawNodeElement -> IO (Ptr CDouble)

foreign import ccall interruptible
               "OGDFGraphAttributes.h GraphAttributes_boundingBox"
               c_graphattributes_boundingbox ::
               Ptr RawGraphAttributes -> IO (Ptr RawDRect)
